package com.biganto.visual.roompark.presentation.screen.splash

import android.view.View
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.ICollapsingToolBar
import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.conductor.BigantoBaseController
import com.biganto.visual.roompark.presentation.screen.auth.AuthScreenController
import com.bluelinelabs.conductor.RouterTransaction
import com.bluelinelabs.conductor.changehandler.FadeChangeHandler
import com.google.android.material.snackbar.Snackbar
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */

class SplashScreenController  :
    BigantoBaseController<SplashScreenViewState
        , SplashScreen
        , SplashScreenPresenter>()
   , SplashScreen {

    
    override fun onViewBound(v: View) {
    }

    override fun injectDependencies() {
        getComponent()
    }

    @Inject
    lateinit var tb: ICollapsingToolBar

    @Inject
    override lateinit var injectedPresenter: SplashScreenPresenter


//    @Inject
//    lateinit var snacky:ISnackBarProvider

    lateinit var rpActivity: RoomParkMainActivity

    fun getComponent() = DaggerSplashScreenComponent
        .factory()
        .create(RoomParkApplication.component,activity as RoomParkMainActivity)
        .inject(this)

//    @Inject
//    lateinit var ac: RoomParkMainActivity


    override fun render(viewState: SplashScreenViewState) {
        when(viewState){
            is SplashScreenViewState.Idle -> render(viewState)
            is SplashScreenViewState.ToScreen -> render(viewState)
        }
    }

    private fun render(viewState: SplashScreenViewState.Idle){

    }

    private fun render(viewState: SplashScreenViewState.ToScreen){
        snackbar.showSnackBar(viewState.message, Snackbar.LENGTH_LONG)
//        tb.hideAll()
        router.pushController(RouterTransaction.with(AuthScreenController())
            .popChangeHandler(FadeChangeHandler())
            .pushChangeHandler(FadeChangeHandler())
        )
//        snacky.showSnackBar("lul")
    }


    override fun getLayoutId(): Int = R.layout.splash_screen


}